Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 12515)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveStatisticsGenerator.cs	(revision 12516)
@@ -32,4 +32,5 @@
     private const string UnknownUserName = "Unknown";
     private static readonly TimeSpan SmallestTimeSpan = new TimeSpan(0, 5, 0);
+    private static readonly TaskState[] CompletedStates = { TaskState.Finished, TaskState.Aborted, TaskState.Failed };
 
     public void GenerateStatistics() {
@@ -42,11 +43,21 @@
         });
 
+        DimTime time = null;
         pm.UseTransaction(() => {
-          var newTime = UpdateDimTimeTable(pm);
-          if (newTime != null) {
+          time = UpdateDimTimeTable(pm);
+          pm.SubmitChanges();
+        });
+
+        if (time != null) {
+          pm.UseTransaction(() => {
+            UpdateFactClientInfoTable(time, pm);
             pm.SubmitChanges();
-            UpdateFactClientInfoTable(newTime, pm);
-            UpdateTaskFactsTable(newTime, pm);
+          });
+
+          pm.UseTransaction(() => {
+            UpdateTaskFactsTable(time, pm);
             try {
+              pm.SubmitChanges();
+              UpdateExistingDimJobs(pm);
               pm.SubmitChanges();
             }
@@ -58,6 +69,6 @@
                           Exception Details: {0}", e));
             }
-          }
-        });
+          });
+        }
       }
     }
@@ -97,4 +108,5 @@
       var dimJobDao = pm.DimJobDao;
       var jobDao = pm.JobDao;
+      var taskDao = pm.TaskDao;
       var dimJobIds = dimJobDao.GetAll().Select(x => x.JobId);
       var newJobs = jobDao.GetAll()
@@ -104,5 +116,6 @@
           UserId = x.OwnerUserId,
           JobName = x.Name ?? string.Empty,
-          DateCreated = x.DateCreated
+          DateCreated = x.DateCreated,
+          TotalTasks = taskDao.GetAll().Count(y => y.JobId == x.JobId)
         })
         .ToList();
@@ -112,6 +125,34 @@
         UserId = x.UserId,
         UserName = GetUserName(x.UserId),
-        DateCreated = x.DateCreated
+        DateCreated = x.DateCreated,
+        TotalTasks = x.TotalTasks,
+        CompletedTasks = 0,
+        DateCompleted = null
       }));
+    }
+
+    private void UpdateExistingDimJobs(PersistenceManager pm) {
+      var dimJobDao = pm.DimJobDao;
+      var factTaskDao = pm.FactTaskDao;
+      foreach (var dimJob in dimJobDao.GetNotCompletedJobs()) {
+        var taskStates = factTaskDao.GetByJobId(dimJob.JobId)
+            .GroupBy(x => x.TaskState)
+            .Select(x => new {
+              State = x.Key,
+              Count = x.Count()
+            }).ToList();
+        int totalTasks = 0, completedTasks = 0;
+        foreach (var state in taskStates) {
+          totalTasks += state.Count;
+          if (CompletedStates.Contains(state.State)) {
+            completedTasks += state.Count;
+          }
+        }
+        if (totalTasks == completedTasks) {
+          dimJob.DateCompleted = factTaskDao.GetLastCompletedTaskFromJob(dimJob.JobId);
+        }
+        dimJob.TotalTasks = totalTasks;
+        dimJob.CompletedTasks = completedTasks;
+      }
     }
 
@@ -120,5 +161,5 @@
       var slaveDao = pm.SlaveDao;
       var slaves = slaveDao.GetAll();
-      var recentlyAddedClients = dimClientDao.GetRecentlyAddedClients();
+      var recentlyAddedClients = dimClientDao.GetActiveClients();
       var slaveIds = slaves.Select(x => x.ResourceId);
 
@@ -136,5 +177,5 @@
           ClientId = client.Id
         };
-      var clientIds = dimClientDao.GetAll().Select(x => x.ResourceId);
+      var clientIds = dimClientDao.GetActiveClients().Select(x => x.ResourceId);
       var modifiedClientIds = modifiedClients.Select(x => x.SlaveId);
       var newClients = slaves
@@ -145,5 +186,7 @@
           x.Name,
           ResourceGroupId = x.ParentResourceId,
-          ResourceGroup2Id = x.ParentResource.ParentResourceId
+          GroupName = x.ParentResource.Name,
+          ResourceGroup2Id = x.ParentResource.ParentResourceId,
+          GroupName2 = x.ParentResource.ParentResource.Name
         })
         .ToList();
@@ -156,5 +199,7 @@
         ExpirationTime = null,
         ResourceGroupId = x.ResourceGroupId,
-        ResourceGroup2Id = x.ResourceGroup2Id
+        GroupName = x.GroupName,
+        ResourceGroup2Id = x.ResourceGroup2Id,
+        GroupName2 = x.GroupName2
       }));
     }
@@ -167,5 +212,5 @@
       var newRawFactInfos =
         from s in slaveDao.GetAll()
-        join c in dimClientDao.GetRecentlyAddedClients() on s.ResourceId equals c.ResourceId
+        join c in dimClientDao.GetActiveClients() on s.ResourceId equals c.ResourceId
         join lcf in factClientInfoDao.GetLastUpdateTimestamps() on c.ResourceId equals lcf.ResourceId into joinCf
         from cf in joinCf.DefaultIfEmpty()
@@ -186,6 +231,6 @@
         from x in newRawFactInfos.ToList()
         let duration = x.LastFactTimestamp != null
-                       ? (newTime.Time - (DateTime)x.LastFactTimestamp).TotalMinutes
-                       : SmallestTimeSpan.TotalMinutes
+                       ? (int)(newTime.Time - (DateTime)x.LastFactTimestamp).TotalSeconds
+                       : (int)SmallestTimeSpan.TotalSeconds
         select new FactClientInfo {
           ClientId = x.ClientId,
@@ -193,5 +238,5 @@
           UserId = x.UserId,
           NumUsedCores = x.TotalCores - x.FreeCores,
-          NumTotalCores = x.TotalMemory,
+          NumTotalCores = x.TotalCores,
           UsedMemory = x.TotalMemory - x.FreeMemory,
           TotalMemory = x.TotalMemory,
@@ -199,5 +244,4 @@
           SlaveState = x.SlaveState,
           TotalTimeIdle = x.SlaveState == SlaveState.Idle && x.IsAllowedToCalculate ? duration : 0.0,
-          TotalTimeCalculating = x.SlaveState == SlaveState.Calculating ? duration : 0.0,
           TotalTimeUnavailable = x.SlaveState == SlaveState.Idle && !x.IsAllowedToCalculate ? duration : 0.0,
           TotalTimeOffline = x.SlaveState == SlaveState.Offline ? duration : 0.0
@@ -226,5 +270,5 @@
         join lastFactTask in notFinishedFactTasks on task.TaskId equals lastFactTask.TaskId into lastFactPerTask
         from lastFact in lastFactPerTask.DefaultIfEmpty()
-        join client in dimClientDao.GetRecentlyAddedClients() on lastSlaveId equals client.ResourceId into clientsPerSlaveId
+        join client in dimClientDao.GetActiveClients() on lastSlaveId equals client.ResourceId into clientsPerSlaveId
         from client in clientsPerSlaveId.DefaultIfEmpty()
         select new {
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 12515)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 12516)
@@ -315,8 +315,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.GeoIP\1.12\HeuristicLab.GeoIP.csproj">
-      <Project>{BE9B0229-9150-49A4-AEA6-BB58E055992F}</Project>
-      <Name>HeuristicLab.GeoIP</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Services.Access.DataAccess\3.3\HeuristicLab.Services.Access.DataAccess-3.3.csproj">
       <Project>{0F652437-998A-4EAB-8BF1-444B5FE8CE97}</Project>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/HeuristicLab.Services.WebApp.Statistics-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/HeuristicLab.Services.WebApp.Statistics-3.3.csproj	(revision 12515)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/HeuristicLab.Services.WebApp.Statistics-3.3.csproj	(revision 12516)
@@ -140,10 +140,22 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="WebApi\DataController.cs" />
+    <Compile Include="WebApi\ClientController.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="WebApi\DataTransfer\Client.cs" />
+    <Compile Include="WebApi\DataTransfer\ClientDetails.cs" />
+    <Compile Include="WebApi\DataTransfer\ClientPage.cs" />
+    <Compile Include="WebApi\DataTransfer\ClientStatus.cs" />
+    <Compile Include="WebApi\DataTransfer\Integer.cs" />
     <Compile Include="WebApi\DataTransfer\Job.cs" />
+    <Compile Include="WebApi\DataTransfer\JobDetails.cs" />
+    <Compile Include="WebApi\DataTransfer\JobPage.cs" />
     <Compile Include="WebApi\DataTransfer\Task.cs" />
+    <Compile Include="WebApi\DataTransfer\TaskPage.cs" />
+    <Compile Include="WebApi\DataTransfer\TaskStateCount.cs" />
     <Compile Include="WebApi\DataTransfer\User.cs" />
+    <Compile Include="WebApi\JavascriptUtils.cs" />
+    <Compile Include="WebApi\JobController.cs" />
+    <Compile Include="WebApi\TaskController.cs" />
+    <Compile Include="WebApi\UserController.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -151,14 +163,41 @@
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
+    <Content Include="WebApp\clients\details\clientDetailsCtrl.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
     <Content Include="WebApp\clients\clientsCtrl.js">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
+    <Content Include="WebApp\clients\details\clientTaskDetailsDialogCtrl.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="WebApp\jobs\details\jobDetailsCtrl.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="WebApp\jobs\details\jobTaskDetailsDialogCtrl.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
     <Content Include="WebApp\jobs\jobsCtrl.js">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
+    <Content Include="WebApp\services\clientService.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="WebApp\services\jobService.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
     <Content Include="WebApp\services\statisticsService.js">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
+    <Content Include="WebApp\services\taskService.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="WebApp\services\userService.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
     <Content Include="WebApp\statistics.css">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="WebApp\users\details\userDetailsCtrl.js">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
@@ -179,4 +218,19 @@
     </Content>
     <Content Include="WebApp\users\users.cshtml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <None Include="WebApp\clients\details\clientDetails.cshtml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
+    <None Include="WebApp\clients\details\clientTaskDetailsDialog.cshtml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
+    <None Include="WebApp\jobs\details\jobDetails.cshtml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
+    <None Include="WebApp\jobs\details\jobTaskDetailsDialog.cshtml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
+    <Content Include="WebApp\users\details\userDetails.cshtml">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 12516)
@@ -0,0 +1,189 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using HeuristicLab.Services.WebApp.Status.WebApi;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+
+  [Authorize]
+  public class ClientController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public DT.ClientDetails GetClientDetails(Guid id) {
+      using (var pm = PersistenceManager) {
+        var dimClientDao = pm.DimClientDao;
+        var factClientInfoDao = pm.FactClientInfoDao;
+        var factTaskDao = pm.FactTaskDao;
+        return pm.UseTransaction(() => {
+          var timeData = factClientInfoDao.GetByClientId(id)
+            .GroupBy(x => x.ClientId)
+            .Select(x => new {
+              TotalIdleTime = (long)x.Sum(y => y.TotalTimeIdle),
+              TotalOfflineTime = (long)x.Sum(y => y.TotalTimeOffline),
+              TotalUnavailableTime = (long)x.Sum(y => y.TotalTimeUnavailable)
+            }).FirstOrDefault();
+          var taskTimeData = factTaskDao.GetByClientId(id)
+            .GroupBy(x => x.LastClientId)
+            .Select(x => new {
+              TotalCalculatingTime = (long)x.Sum(y => y.CalculatingTime),
+              TotalTransferringTime = (long)x.Sum(y => y.TransferTime)
+            }).FirstOrDefault();
+          var startDate = factClientInfoDao.GetByClientId(id)
+            .Where(x => x.SlaveState == SlaveState.Offline)
+            .OrderByDescending(x => x.Time)
+            .Select(x => x.Time).FirstOrDefault();
+          long upTime = 0;
+          if (startDate == default(DateTime)) {
+            startDate = factClientInfoDao.GetByClientId(id)
+              .OrderByDescending(x => x.Time)
+              .Select(x => x.Time)
+              .FirstOrDefault();
+          }
+          if (startDate != default(DateTime)) {
+            upTime = (long)(DateTime.Now - startDate).TotalSeconds;
+          }
+          return (from client in dimClientDao.GetAll().Where(x => x.Id == id)
+                  join info in factClientInfoDao.GetAll()
+                    on client.Id equals info.ClientId into clientInfoJoin
+                  from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
+                  let offline = (client.ExpirationTime != null || clientInfo.SlaveState == SlaveState.Offline)
+                  select new DT.ClientDetails {
+                    Id = client.Id,
+                    Name = client.Name,
+                    TotalCores = clientInfo.NumTotalCores,
+                    UsedCores = offline ? 0 : clientInfo.NumUsedCores,
+                    TotalMemory = clientInfo.TotalMemory,
+                    UsedMemory = offline ? 0 : clientInfo.UsedMemory,
+                    CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
+                    State = clientInfo.SlaveState.ToString(),
+                    LastUpdate = clientInfo.Time,
+                    UpTime = offline ? 0 : upTime,
+                    TotalUnavailableTime = timeData != null ? timeData.TotalUnavailableTime : 0,
+                    TotalCalculatingTime = taskTimeData != null ? taskTimeData.TotalCalculatingTime : 0,
+                    TotalIdleTime = timeData != null ? timeData.TotalIdleTime : 0,
+                    TotalOfflineTime = timeData != null ? timeData.TotalOfflineTime : 0,
+                    TotalTransferringTime = taskTimeData != null ? taskTimeData.TotalTransferringTime : 0,
+                    TasksStates = factTaskDao.GetByClientId(id)
+                                    .GroupBy(x => x.TaskState)
+                                    .Select(x => new DT.TaskStateCount {
+                                      State = x.Key.ToString(),
+                                      Count = x.Count()
+                                    }).ToList()
+                  })
+                  .FirstOrDefault();
+        });
+      }
+    }
+
+    public DT.ClientPage GetClients(int page, int size, bool expired = false) {
+      using (var pm = PersistenceManager) {
+        var dimClientDao = pm.DimClientDao;
+        var factClientInfoDao = pm.FactClientInfoDao;
+        return pm.UseTransaction(() => {
+          var clients = expired ? dimClientDao.GetExpiredClients() : dimClientDao.GetActiveClients();
+          var query = (from client in clients
+                       join info in factClientInfoDao.GetAll()
+                         on client.Id equals info.ClientId into clientInfoJoin
+                       from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
+                       let offline = (expired || clientInfo.SlaveState == SlaveState.Offline)
+                       select new DT.Client {
+                         Id = client.Id,
+                         Name = client.Name,
+                         TotalCores = clientInfo.NumTotalCores,
+                         UsedCores = offline ? 0 : clientInfo.NumUsedCores,
+                         TotalMemory = clientInfo.TotalMemory,
+                         UsedMemory = offline ? 0 : clientInfo.UsedMemory,
+                         CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
+                         State = clientInfo.SlaveState.ToString(),
+                       });
+          return new DT.ClientPage {
+            TotalClients = query.Count(),
+            Clients = query.Skip((page - 1) * size)
+              .Take(size)
+              .ToList()
+          };
+        });
+      }
+    }
+
+    public IEnumerable<DT.ClientStatus> GetClientHistory(Guid id, DateTime start, DateTime end) {
+      TimeSpan ts = end - start;
+      int increment = 1;
+      double totalMinutes = ts.TotalMinutes;
+      while (totalMinutes > 5761) {
+        totalMinutes -= 5761;
+        increment += 5;
+      }
+      using (var pm = PersistenceManager) {
+        var factClientInfo = pm.FactClientInfoDao;
+        var clientInfos = factClientInfo.GetByClientId(id)
+          .Where(x => x.Time >= start && x.Time <= end)
+          .OrderBy(x => x.Time)
+          .ToList();
+        var clientStatus = new DT.ClientStatus {
+          CpuUtilization = 0,
+          TotalCores = 0,
+          UsedCores = 0,
+          TotalMemory = 0,
+          UsedMemory = 0
+        };
+        int i = 1;
+        foreach (var clientInfo in clientInfos) {
+          clientStatus.CpuUtilization += clientInfo.CpuUtilization;
+          clientStatus.TotalCores += clientInfo.NumTotalCores;
+          clientStatus.UsedCores += clientInfo.NumUsedCores;
+          clientStatus.TotalMemory += clientInfo.TotalMemory;
+          clientStatus.UsedMemory += clientInfo.UsedMemory;
+          if (i >= increment) {
+            clientStatus.Timestamp = JavascriptUtils.ToTimestamp(clientInfo.Time);
+            clientStatus.CpuUtilization /= i;
+            clientStatus.TotalCores /= i;
+            clientStatus.UsedCores /= i;
+            clientStatus.TotalMemory /= i;
+            clientStatus.UsedMemory /= i;
+            yield return clientStatus;
+            clientStatus = new DT.ClientStatus {
+              CpuUtilization = 0,
+              TotalCores = 0,
+              UsedCores = 0,
+              TotalMemory = 0,
+              UsedMemory = 0
+            };
+            i = 1;
+          } else {
+            ++i;
+          }
+        }
+      }
+    }
+
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Client.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Client.cs	(revision 12515)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Client.cs	(revision 12516)
@@ -26,4 +26,11 @@
     public Guid Id { get; set; }
     public string Name { get; set; }
+    public int TotalCores { get; set; }
+    public int UsedCores { get; set; }
+    public int TotalMemory { get; set; }
+    public int UsedMemory { get; set; }
+    public double CpuUtilization { get; set; }
+    public string State { get; set; }
+    public DateTime LastUpdate { get; set; }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientDetails.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientDetails.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientDetails.cs	(revision 12516)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class ClientDetails {
+    public Guid Id { get; set; }
+    public string Name { get; set; }
+    public int TotalCores { get; set; }
+    public int UsedCores { get; set; }
+    public int TotalMemory { get; set; }
+    public int UsedMemory { get; set; }
+    public double CpuUtilization { get; set; }
+    public string State { get; set; }
+    public DateTime LastUpdate { get; set; }
+    public long UpTime { get; set; }
+    public long TotalUnavailableTime { get; set; }
+    public long TotalCalculatingTime { get; set; }
+    public long TotalIdleTime { get; set; }
+    public long TotalOfflineTime { get; set; }
+    public long TotalTransferringTime { get; set; }
+    public IEnumerable<TaskStateCount> TasksStates { get; set; }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientPage.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientPage.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientPage.cs	(revision 12516)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class ClientPage {
+    public int TotalClients { get; set; }
+    public IEnumerable<Client> Clients { get; set; }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientStatus.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientStatus.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientStatus.cs	(revision 12516)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class ClientStatus {
+    public long Timestamp { get; set; }
+    public int TotalCores { get; set; }
+    public int UsedCores { get; set; }
+    public int TotalMemory { get; set; }
+    public int UsedMemory { get; set; }
+    public double CpuUtilization { get; set; }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Integer.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Integer.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Integer.cs	(revision 12516)
@@ -0,0 +1,26 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class Integer {
+    public int Value { get; set; }
+  }
+}
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Job.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Job.cs	(revision 12515)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Job.cs	(revision 12516)
@@ -26,5 +26,10 @@
     public Guid Id { get; set; }
     public string Name { get; set; }
+    public Guid UserId { get; set; }
+    public string UserName { get; set; }
     public DateTime DateCreated { get; set; }
+    public int TotalTasks { get; set; }
+    public int CompletedTasks { get; set; }
+    public DateTime? DateCompleted { get; set; }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobDetails.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobDetails.cs	(revision 12516)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobDetails.cs	(revision 12516)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class JobDetails {
+    public Guid Id { get; set; }
+    public string Name { get; set; }
+    public Guid UserId { get; set; }
+    public string UserName { get; set; }
+    public DateTime DateCreated { get; set; }
+    public int TotalTasks { get; set; }
+    public int CompletedTasks { get; set; }
+    public DateTime? DateCompleted { get; set; }
+    public long AvgTransferringTime { get; set; }
+    public long MinCalculatingTime { get; set; }
+    public long MaxCalculatingTime { get; set; }
+    public long AvgCalculatingTime { get; set; }
+    public long TotalCalculatingTime { get; set; }
+    public long TotalWaitingTime { get; set; }
+    public long TotalTime { get; set; }
+    public IEnumerable<TaskStateCount> TasksStates { get; set; }
+  }
+}
